【HDU】2614 Beat(C++/C)

Problem Description
Zty is a man that always full of enthusiasm. He wants to solve every kind of difficulty ACM problem in the world. And he has a habit that he does not like to solve
a problem that is easy than problem he had solved. Now yifenfei give him n difficulty problems, and tell him their relative time to solve it after solving the other one.
You should help zty to find a order of solving problems to solve more difficulty problem. 
You may sure zty first solve the problem 0 by costing 0 minute. Zty always choose cost more or equal time’s problem to solve.
 

Input
The input contains multiple test cases.
Each test case include, first one integer n ( 2< n < 15).express the number of problem.
Than n lines, each line include n integer Tij ( 0<=Tij<10), the i’s row and j’s col integer Tij express after solving the problem i, will cost Tij minute to solve the problem j.
 

Output
For each test case output the maximum number of problem zty can solved.


 

Sample Input
 
  
3 0 0 0 1 0 1 1 0 0 3 0 2 2 1 0 1 1 1 0 5 0 1 2 3 1 0 0 2 3 1 0 0 0 3 1 0 0 0 0 2 0 0 0 0 0
 

Sample Output
 
  
3 2 4
Hint
Hint: sample one, as we know zty always solve problem 0 by costing 0 minute. So after solving problem 0, he can choose problem 1 and problem 2, because T01 >=0 and T02>=0. But if zty chooses to solve problem 1, he can not solve problem 2, because T12 < T01. So zty can choose solve the problem 2 second, than solve the problem 1.

题意:一个人做题,他的习惯是只做越来越难的题目,也就是花费时间越长的题目。矩阵中第i行第j列的元素表示做完第i题之后做第j题要花费的时间。要求找到这个人能做的最多的题目数。每次都从第一道题开始做。

代码:

//
//  main.cpp
//  2614
//
//  Created by showlo on 2018/5/19.
//  Copyright © 2018年 showlo. All rights reserved.
//

#include <iostream>
#include <algorithm>
using namespace std;
int n;
int a[20][20];
int vis[20];
int sum;
int maxi;

//dfs中p表示目前做完的题目,sum表示目前完成的题目数量,cost表示做p所用的时间

void dfs(int p,int sum,int cost)
{
    maxi=max(sum, maxi);  //更新最多题目数
    if(maxi==n)
        return;     //如果已经做完n题,返回
    
    for (int i=1; i<n; i++) {
        if (vis[i]==0&&a[p][i]>=cost) {   //如果这道题没有做“vis[i]=0”,并且花费时间大于等于目前所用时间,就做这道题
            vis[i]=1;
            dfs(i,sum+1,a[p][i]);
            vis[i]=0;
        }
    }
}

int main() {
    while (cin>>n) {
        maxi=0;
        memset(a, 0, sizeof(a));
        memset(vis, 0, sizeof(vis));
        for (int i=0; i<n; i++)
            for (int j=0; j<n; j++)
                cin>>a[i][j];
        vis[0]=1;     //第一道题已做完
        dfs(0,1,0);
        cout<<maxi<<endl;
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/biongbiongdou/article/details/80373216